#[doc = "Register `DWT_PID4` reader"]
pub struct R(crate::R<DWT_PID4_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<DWT_PID4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<DWT_PID4_SPEC>> for R {
    fn from(reader: crate::R<DWT_PID4_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `DWT_PID4` writer"]
pub struct W(crate::W<DWT_PID4_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<DWT_PID4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<DWT_PID4_SPEC>> for W {
    fn from(writer: crate::W<DWT_PID4_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `VALUE` reader - Peripheral ID #4"]
pub struct VALUE_R(crate::FieldReader<u32, u32>);
impl VALUE_R {
    pub(crate) fn new(bits: u32) -> Self {
        VALUE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for VALUE_R {
    type Target = crate::FieldReader<u32, u32>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:31 - Peripheral ID #4"]
    #[inline(always)]
    pub fn value(&self) -> VALUE_R {
        VALUE_R::new((self.bits & 0xffff_ffff) as u32)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Watchpoint Unit CoreSight ROM Table Peripheral ID #4\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dwt_pid4](index.html) module"]
pub struct DWT_PID4_SPEC;
impl crate::RegisterSpec for DWT_PID4_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [dwt_pid4::R](R) reader structure"]
impl crate::Readable for DWT_PID4_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [dwt_pid4::W](W) writer structure"]
impl crate::Writable for DWT_PID4_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets DWT_PID4 to value 0"]
impl crate::Resettable for DWT_PID4_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
